//------------------------------------------------------------------------------
//
//  DelphiDoom: A modified and improved DOOM engine for Windows
//  based on original Linux Doom as published by "id Software"
//  Copyright (C) 2004-2007 by Jim Valavanis
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.
//
//------------------------------------------------------------------------------
//  E-Mail: jimmyvalavanis@yahoo.gr
//  Site  : http://delphidoom.sitesled.com/
//------------------------------------------------------------------------------

{$IFDEF FPC}
{$Error: Use you must use Delphi to compile this project. Use Doom32f.dpr with FPC}
{$ENDIF}

{$I Doom32.inc}
{$D Doom to Delphi Total Conversion}

program Doom32;

{$R *.RES}

uses
  FastMM4 in 'FastMM4.pas',
  am_map in 'am_map.pas',
  c_cmds in 'c_cmds.pas',
  c_con in 'c_con.pas',
  c_utils in 'c_utils.pas',
  d_delphi in 'd_delphi.pas',
  d_englsh in 'd_englsh.pas',
  d_event in 'd_event.pas',
  d_items in 'd_items.pas',
  d_main in 'd_main.pas',
  d_net in 'd_net.pas',
  d_net_h in 'd_net_h.pas',
  d_player in 'd_player.pas',
  d_textur in 'd_textur.pas',
  d_think in 'd_think.pas',
  d_ticcmd in 'd_ticcmd.pas',
  deh_main in 'deh_main.pas',
  doomdata in 'doomdata.pas',
  doomdef in 'doomdef.pas',
  doomstat in 'doomstat.pas',
  doomtype in 'doomtype.pas',
  dstrings in 'dstrings.pas',
  f_finale in 'f_finale.pas',
  f_wipe in 'f_wipe.pas',
  g_game in 'g_game.pas',
  hu_lib in 'hu_lib.pas',
  hu_stuff in 'hu_stuff.pas',
  i_input in 'i_input.pas',
  i_io in 'i_io.pas',
  i_main in 'i_main.pas',
  i_midi in 'i_midi.pas',
  i_mp3 in 'i_mp3.pas',
  i_music in 'i_music.pas',
  i_net in 'i_net.pas',
  i_sound in 'i_sound.pas',
  i_system in 'i_system.pas',
  i_video in 'i_video.pas',
  info in 'info.pas',
  info_h in 'info_h.pas',
  info_rnd in 'info_rnd.pas',
  m_argv in 'm_argv.pas',
  m_bbox in 'm_bbox.pas',
  m_cheat in 'm_cheat.pas',
  m_defs in 'm_defs.pas',
  m_fixed in 'm_fixed.pas',
  m_menu in 'm_menu.pas',
  m_misc in 'm_misc.pas',
  m_rnd in 'm_rnd.pas',
  m_stack in 'm_stack.pas',
  m_vectors in 'm_vectors.pas',
  mp3_Args in 'mp3_Args.pas',
  mp3_BitReserve in 'mp3_BitReserve.pas',
  mp3_BitStream in 'mp3_BitStream.pas',
  mp3_CRC in 'mp3_CRC.pas',
  mp3_Header in 'mp3_Header.pas',
  mp3_Huffman in 'mp3_Huffman.pas',
  mp3_InvMDT in 'mp3_InvMDT.pas',
  mp3_L3Tables in 'mp3_L3Tables.pas',
  mp3_L3Type in 'mp3_L3Type.pas',
  mp3_Layer3 in 'mp3_Layer3.pas',
  mp3_MPEGPlayer in 'mp3_MPEGPlayer.pas',
  mp3_OBuffer in 'mp3_OBuffer.pas',
  mp3_OBuffer_MCI in 'mp3_OBuffer_MCI.pas',
  mp3_OBuffer_Wave in 'mp3_OBuffer_Wave.pas',
  mp3_Player in 'mp3_Player.pas',
  mp3_ScaleFac in 'mp3_ScaleFac.pas',
  mp3_Shared in 'mp3_Shared.pas',
  mp3_SubBand in 'mp3_SubBand.pas',
  mp3_SubBand1 in 'mp3_SubBand1.pas',
  mp3_SubBand2 in 'mp3_SubBand2.pas',
  mp3_SynthFilter in 'mp3_SynthFilter.pas',
  p_ceilng in 'p_ceilng.pas',
  p_doors in 'p_doors.pas',
  p_enemy in 'p_enemy.pas',
  p_extra in 'p_extra.pas',
  p_floor in 'p_floor.pas',
  p_inter in 'p_inter.pas',
  p_lights in 'p_lights.pas',
  p_local in 'p_local.pas',
  p_map in 'p_map.pas',
  p_maputl in 'p_maputl.pas',
  p_mobj in 'p_mobj.pas',
  p_mobj_h in 'p_mobj_h.pas',
  p_plats in 'p_plats.pas',
  p_pspr in 'p_pspr.pas',
  p_pspr_h in 'p_pspr_h.pas',
  p_saveg in 'p_saveg.pas',
  p_setup in 'p_setup.pas',
  p_sight in 'p_sight.pas',
  p_sounds in 'p_sounds.pas',
  p_spec in 'p_spec.pas',
  p_switch in 'p_switch.pas',
  p_telept in 'p_telept.pas',
  p_terrain in 'p_terrain.pas',
  p_tick in 'p_tick.pas',
  p_user in 'p_user.pas',
  r_bsp in 'r_bsp.pas',
  r_cache in 'r_cache.pas',
  r_ccache in 'r_ccache.pas',
  r_col_al in 'r_col_al.pas',
  r_col_av in 'r_col_av.pas',
  r_col_fz in 'r_col_fz.pas',
  r_col_l in 'r_col_l.pas',
  r_col_ms in 'r_col_ms.pas',
  r_col_sk in 'r_col_sk.pas',
  r_col_tr in 'r_col_tr.pas',
  r_column in 'r_column.pas',
  r_data in 'r_data.pas',
  r_defs in 'r_defs.pas',
  r_draw in 'r_draw.pas',
  r_fake3d in 'r_fake3d.pas',
  r_grow in 'r_grow.pas',
  r_hires in 'r_hires.pas',
  r_intrpl in 'r_intrpl.pas',
  r_lights in 'r_lights.pas',
  r_main in 'r_main.pas',
  r_mmx in 'r_mmx.pas',
  r_plane in 'r_plane.pas',
  r_scache in 'r_scache.pas',
  r_segs in 'r_segs.pas',
  r_sky in 'r_sky.pas',
  r_span in 'r_span.pas',
  r_span32 in 'r_span32.pas',
  r_things in 'r_things.pas',
  rtl_types in 'rtl_types.pas',
  s_sound in 's_sound.pas',
  sc_decorate in 'sc_decorate.pas',
  sc_engine in 'sc_engine.pas',
  sc_params in 'sc_params.pas',
  sounds in 'sounds.pas',
  st_lib in 'st_lib.pas',
  st_stuff in 'st_stuff.pas',
  t_bmp in 't_bmp.pas',
  t_colors in 't_colors.pas',
  t_draw in 't_draw.pas',
  t_main in 't_main.pas',
  t_png in 't_png.pas',
  t_tga in 't_tga.pas',
  tables in 'tables.pas',
  v_data in 'v_data.pas',
  v_video in 'v_video.pas',
  w_pak in 'w_pak.pas',
  w_utils in 'w_utils.pas',
  w_wad in 'w_wad.pas',
  wi_stuff in 'wi_stuff.pas',
  z_files in 'z_files.pas',
  z_zone in 'z_zone.pas',
  e_endoom in 'e_endoom.pas';

var
  Saved8087CW: Word;

begin
  { Save the current FPU state and then disable FPU exceptions }
  Saved8087CW := Default8087CW;
  Set8087CW($133f); { Disable all fpu exceptions }

  try
    DoomMain;
  except
    I_FlashCachedOutput;
  end;

  { Reset the FPU to the previous state }
  Set8087CW(Saved8087CW);

end.
